using System;
using System.Threading;
using ff14bot.Managers;
using ff14bot.AClasses;
using System.Windows;
using System.Windows.Controls;
using Logger = ff14bot.Helpers.Logging;

namespace ZZISaysHi
{

    public class CombatSwitcher : BotPlugin
    {
        public override string Author => "ZZI";
        public override Version Version => new Version(0, 0, 0);
        public override string Name => "CombatSwitcher";
        public override string Description => "Puts a Change Combat Routine button on the main bot page";

        private Button btn;

        public override void OnEnabled()
        {
            if (!Application.Current.MainWindow.CheckAccess())
            {
                Logger.Write("Current Thread {0} '{1}' cannot access MainWindow Dispatcher",
                    Thread.CurrentThread.ManagedThreadId, Thread.CurrentThread.Name);

                return;
            }
            Application.Current.MainWindow.Dispatcher.Invoke(() =>
            {
                var mainWindow = Application.Current.MainWindow;
                var buttons = mainWindow.FindName("BotBox") as ComboBox;
                var Grid = buttons.Parent as Grid;
                btn = new Button
                {
                    Margin = new Thickness(0, 169, 10, 0),
                    IsEnabled = true,
                    HorizontalAlignment = HorizontalAlignment.Right,
                    Width = 129,
                    Height = 18,
                    VerticalAlignment = VerticalAlignment.Top,
                    Content = "Change Combat Routine",
                    Name = "ChangeCR",
                    Visibility = Visibility.Visible,
                };
                btn.Click += ChangeCR;
                Grid.Children.Insert(4, btn);
            });
        }

        private void ChangeCR(object sender, RoutedEventArgs e)
        {
            RoutineManager.PreferedRoutine = "";

            RoutineManager.PickRoutine();
        }

        public override void OnDisabled()
        {
            Application.Current.MainWindow.Dispatcher.Invoke(() =>
            {
                var mainWindow = Application.Current.MainWindow;
                var buttons = mainWindow.FindName("BotBox") as ComboBox;
                var Grid = buttons.Parent as Grid;
                if (btn == null || Grid == null)
                    return;
                Grid.Children.Remove(btn);
            });
        }
    }
}